/*
 *  i386 Host support code
 * 
 *  Copyright (c) 2005 CodeSourcery, LLC
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <inttypes.h>

#include "config.h"
#include "dyngen-host.h"
#include "bitmap.h"

host_reg_bitmap allocatable_regs;

host_reg_bitmap host_reg_classes[NUM_HOST_REG_CLASSES] =
{
  1, /* A */
  2, /* C */
  4, /* D */
  0xc8, /* OTHER */
  0xff00 /* F */
};

void init_host_reg_classes()
{
#if defined(TARGET_X86_64)
    allocatable_regs = 0xcf & ~(1 << HOST_REG_AREG0);
#else
    allocatable_regs = 0x07;
#endif
    allocatable_regs |= 0xff00;
}
