typedef struct qOP {
    struct qOP *prev;
    struct qOP *next;
    uint16_t opcode;
    /* Bitmask for inputs dead in this instruction.  */
    uint8_t dead_regs;
    uint32_t args[0];
} qOP;

enum qreg_type {
    QREGT_UNKNOWN,
    QREGT_REG, /* A hard guest register.  Val is the register number.  */
    QREGT_ENV, /* An offset into the CPUenv.  */
    QREGT_STACK, /* A stack slot.  */
    QREGT_IM  /* An immediate value.  */
};

#define FIRST_HARD_QREG 0x8000
typedef enum {
  QMODE_I32,
  QMODE_I64,
  QMODE_F32,
  QMODE_F64
} qreg_mode;

struct qreg {
    long val;
    qOP *last_seen;
    qreg_mode mode;
    enum qreg_type type;
    int highpart;
    int live_reg;
    unsigned is_live:1;
};

