#include <sys/time.h>
#include <time.h>
#include <inttypes.h>

static uint64_t last_time = 0;
static uint64_t gen_timers[6];
static uint64_t first_time = 0;


void gen_timer(int n)
{
    uint64_t t;
    uint32_t low;
    uint32_t high;

    asm volatile ("rdtsc" : "=a" (low), "=d" (high));
    t = ((uint64_t)high << 32) | low;
    if (last_time)
        gen_timers[n] += (t - last_time);
    else
        first_time = t;
    last_time = t;
}

void maybe_dump_timer(void)
{
    int i;
    uint64_t div;

    if (last_time - first_time < 10000000000ll)
        return;
    div = (last_time - first_time) >> 10;
    printf ("TIMER %5d", getpid());
    for (i = 0; i < 6; i++) {
        printf (" %8d", (int)(gen_timers[i] / div));
        gen_timers[i] = 0;
    }
    first_time = last_time;
    printf ("\n");
}
