#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

#include "config.h"
#include "cpu.h"
#include "exec-all.h"
#include "dyngen.h"
#include "dyngen-host.h"
#include "qop.h"
#include "qop-helper.h"

void *const gen_helper_address[] = {
#define DEF(name) helper_##name,
#include "qop-helper.def"
#undef DEF
};

#define QOP_CODE_START \
int dyngen_qop(uint8_t *gen_code_buf, \
               uint8_t *gen_code_ptr, \
               const qOP *qop, \
               const struct qreg *reginfo, \
               uint16_t *jmp_offsets, \
	       const long *gen_labels) \
{ \
    uint8_t *qop_start = gen_code_ptr; \
    switch (qop->opcode) {
#define QOP_ALIAS(name) case INDEX_op_ ## name:
#define QOP_START(name) case INDEX_op_ ## name: {
    

#define QOP_END } break;
#define QOP_CODE_END \
    case INDEX_op_label: \
    case INDEX_op_unwind: \
        break; \
    default: \
        cpu_abort(NULL, "No code for qop"); \
    } \
    return gen_code_ptr - qop_start; }

#define ARG(n) qop->args[n]
#define OUT8(val) *(gen_code_ptr++) = (val)
#define OUT32(val) \
    do { \
        *(uint32_t *)gen_code_ptr = (val); \
        gen_code_ptr += 4; \
    } while (0)

#define MARK_FIXUP(ptr) ptr = (long)gen_code_ptr
#define RESOLVE_FIXUP(type, ptr) DO_FIXUP_ ## type(ptr, (long)gen_code_ptr)

#define LABEL_OFFSET(n) (gen_labels[n] - (long)gen_code_ptr)

#define MARK_JMP(n) jmp_offsets[n] = gen_code_ptr - gen_code_buf

#include "qop-code.h"

#undef QOP_START
#undef QOP_ALIAS
#undef QOP_END
#undef ARG
#undef OUT8
#undef OUT32
#undef MARK_FIXUP
#undef RESOLVE_FIXUP
#undef MARK_JMP
